稼働時間

ガントシートの各カレンダーは、週間稼働日数、稼働日および稼働時間によって構成され、カスタマイズすることもできます。

説明
app.js
index.html
styles.css

デフォルトの週間稼働日数

週間稼働日数は7日間です。次のサンプルコードはデフォルトの週間稼働日数を取得します:

// プロジェクトのカレンダーから週間稼働日数を取得します。
var calendar = ganttSheet.project.calendar;
console.log(calendar.defaultWorkWeek);

// 組込みカレンダーから週間稼働日数を取得します。
console.log(GC.Spread.Sheets.GanttSheet.Calendar.standard);
console.log(GC.Spread.Sheets.GanttSheet.Calendar.hours24);
console.log(GC.Spread.Sheets.GanttSheet.Calendar.nightShift);

週間稼働日数の変更

次のサンプルコードは、稼働時間を変更します:

var calendar = GC.Spread.Sheets.GanttSheet.Calendar.standard;
var defaultWorkWeek = calendar.defaultWorkWeek;
var workday = defaultWorkWeek.getWorkDay(GC.Spread.Sheets.GanttSheet.DayOfWeek.Monday);
// 時間範囲で稼働日数を構成します。
/*
    [
        { start: { hour: 8, minute: 0 }, end: { hour: 12, minute: 0 } },
        { start: { hour: 13, minute: 0 }, end: { hour: 17, minute: 0 } }
    ]
    // 8:00~12:00 13:00~17:00
*/
workday[1].end.hour = 13;

// カレンダーに適用
ganttSheet.project.calendar = calendar;
デフォルトの週間稼働日数 週間稼働日数は7日間です。次のサンプルコードはデフォルトの週間稼働日数を取得します: 週間稼働日数の変更 次のサンプルコードは、稼働時間を変更します:
/*REPLACE_MARKER*/ /*DO NOT DELETE THESE COMMENTS*/ var myTable; var ganttSheet; var Calendars = { standard: GC.Spread.Sheets.GanttSheet.Calendar.standard, hours24: GC.Spread.Sheets.GanttSheet.Calendar.hours24, nightShift: GC.Spread.Sheets.GanttSheet.Calendar.nightShift }; window.onload = function() { var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), { sheetCount: 0 }); initSpread(spread); initSplitView(spread); }; function initSpread(spread) { spread.suspendPaint(); initDataSource(spread); initGanttSheet(spread); spread.resumePaint(); } function initDataSource(spread) { var tableName = "Gantt_Id"; var baseApiUrl = getBaseApiUrl(); var apiUrl = baseApiUrl + "/" + tableName; var dataManager = spread.dataManager(); myTable = dataManager.addTable("myTable", { batch: true, remote: { read: { url: apiUrl } }, schema: { hierarchy: { type: "Parent", column: "parentId" }, columns: { id: { isPrimaryKey: true }, taskNumber: { dataType: "rowOrder" } } } }); } function initGanttSheet(spread) { ganttSheet = spread.addSheetTab(0, "GanttSheet", GC.Spread.Sheets.SheetType.ganttSheet); var view = myTable.addView("ganttView", [ { value: "taskNumber", caption: "NO.", width: 60 }, { value: "name", caption: "Task Name", width: 200 }, { value: "duration", caption: "Duration", width: 90 }, { value: "predecessors", caption: "Predecessors", width: 120, visible: false } ]); view.fetch().then(function() { ganttSheet.bindGanttView(view); ganttSheet.project.calendar = Calendars.standard; }); initSidePanel(ganttSheet); } function initSidePanel(ganttSheet) { var currentCustomWorkWeek = ganttSheet.project.calendar.defaultWorkWeek; var targetCalendarItem = document.getElementById("target-calendar"); var customTargetDayItem = document.getElementById("target-day"); var addWorkTimeItem = document.getElementById("add-work-time"); var addWorkWeekItem = document.getElementById("add-work-week"); var workTimeTableItem = document.getElementById("work-time-table"); updateWorkingTimeTable(ganttSheet.project.calendar.defaultWorkWeek, 0); targetCalendarItem.addEventListener("change", function() { var calendarType = targetCalendarItem.value; var calendar = Calendars[calendarType]; var workdayIndex = Number(customTargetDayItem.value); currentCustomWorkWeek = calendar.defaultWorkWeek; updateWorkingTimeTable(currentCustomWorkWeek, workdayIndex); ganttSheet.project.calendar = calendar; }); customTargetDayItem.addEventListener("change", function() { var workdayIndex = Number(customTargetDayItem.value); updateWorkingTimeTable(currentCustomWorkWeek, workdayIndex); }); addWorkTimeItem.addEventListener("click", function() { var workdayIndex = Number(customTargetDayItem.value); var workday = currentCustomWorkWeek.getWorkDay(workdayIndex); var workTime = { start: { hour: 0, minute: 0 }, end: { hour: 0, minute: 0 } }; workday.push(workTime); updateWorkingTimeTable(currentCustomWorkWeek, workdayIndex); }); workTimeTableItem.addEventListener("click", function(e) { var target = e.target; if (target.classList.contains("icon-delete")) { var targetWorkTimeIndex = target.dataset.row; var workdayIndex = Number(customTargetDayItem.value); // GC.Spread.Sheets.GanttSheet.DayOfWeek var workday = currentCustomWorkWeek.getWorkDay(workdayIndex); workday.splice(targetWorkTimeIndex, 1); updateWorkingTimeTable(currentCustomWorkWeek, workdayIndex); } }); addWorkWeekItem.addEventListener("click", function() { var calendar = ganttSheet.project.calendar; var workdayIndex = Number(customTargetDayItem.value); // GC.Spread.Sheets.GanttSheet.DayOfWeek var workday = currentCustomWorkWeek.getWorkDay(workdayIndex); updateWorkingTime(workday); calendar.defaultWorkWeek = currentCustomWorkWeek; ganttSheet.project.calendar = calendar; }); function updateWorkingTime(workday) { var rows = workTimeTableItem.getElementsByTagName("tr"); if (rows) { for (var i = 0; i < rows.length; i ++) { var row = rows[i]; var workTime = workday[i]; var startItemValue = row.getElementsByClassName("start-item")[0].value; var endItemValue = row.getElementsByClassName("end-item")[0].value; var start = parseTimeString(startItemValue); var end = parseTimeString(endItemValue); if (start) { workTime.start = start; } if (end) { workTime.end = end; } } } } function updateWorkingTimeTable(customWorkWeeks, workdayIndex) { var workday = customWorkWeeks.getWorkDay(workdayIndex); var tableInnerHTML = ""; for (var i = 0; i < workday.length; i ++) { var workTime = workday[i]; var from = `${convertTimeString(workTime.start.hour)}:${convertTimeString(workTime.start.minute)}`; var to = `${convertTimeString(workTime.end.hour)}:${convertTimeString(workTime.end.minute)}`; var rowHTML = ` <tr> <td><input type="text" class="input-date start-item" value="${from}" /></td> <td><input type="text" class="input-date end-item" value="${to}" /></td> ${getTableFunctionalColumn(false, true, i)} </tr> `; tableInnerHTML += rowHTML; } workTimeTableItem.innerHTML = tableInnerHTML; } function getTableFunctionalColumn(needEdit, needDelete, index) { return ` <td> ${needEdit ? `<span class="icon icon-edit" ${typeof index === "number" ? "data-row=" + index : ""}>edit</span>` : ""} ${needDelete ? `<span class="icon icon-delete" ${typeof index === "number" ? "data-row=" + index : ""}>削除</span>` : ""} </td> `; } function convertTimeString(num) { if (num < 10) { return "0" + num; } else { return num.toString(); } } function parseTimeString(timeString) { var hourAndMinute = timeString.split(":"); if (hourAndMinute && hourAndMinute.length === 2) { return { hour: Number(hourAndMinute[0]), minute: Number(hourAndMinute[1]) }; } } } function getBaseApiUrl() { return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api'; } function initSplitView(spread) { var host = document.getElementById("split-view"); var content = host.getElementsByClassName("split-content")[0]; var panel = host.getElementsByClassName("split-panel")[0]; var defaultPanelWidth = 340; new SplitView({ host: host, content: content, panel: panel, defaultPanelWidth: defaultPanelWidth, refreshContent: function() { spread.refresh(); } }); }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="spreadjs culture" content="ja-jp" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/ja/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/spread/source/splitView/splitView.css"> <!-- Promise Polyfill for IE, https://www.npmjs.com/package/promise-polyfill --> <script src="https://cdn.jsdelivr.net/npm/promise-polyfill@8/dist/polyfill.min.js"></script> <script src="$DEMOROOT$/ja/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/ja/purejs/node_modules/@mescius/spread-sheets-tablesheet/dist/gc.spread.sheets.tablesheet.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/ja/purejs/node_modules/@mescius/spread-sheets-ganttsheet/dist/gc.spread.sheets.ganttsheet.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/ja/purejs/node_modules/@mescius/spread-sheets-resources-ja/dist/gc.spread.sheets.resources.ja.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/splitView/splitView.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div id="split-view" class="sample-tutorial"> <div id="ss" class="sample-spreadsheets split-content"></div> <div class="options-container split-panel"> <div class="option-row option-title"> 稼働時間を設定します。 </div> <div class="option-block"> <div class="option-row selection-box"> <label for="target-calendar">対象のカレンダー</label> <select id="target-calendar"> <option value="standard" selected>標準</option> <option value="hours24">24時間制</option> <option value="nightShift">夜間シフト</option> </select> </div> </div> <div class="option-block toggle"> <div class="option-row option-title clear-float"> <span class="float-left">週間稼働詳細</span> </div> <div class="option-row selection-box"> <label for="target-day">稼働日</label> <select id="target-day"> <option value="0" selected>日曜日</option> <option value="1">月曜日</option> <option value="2">火曜日</option> <option value="3">水曜日</option> <option value="4">木曜日</option> <option value="5">金曜日</option> <option value="6">土曜日</option> </select> </div> <div class="option-row"> <input type="button" id="add-work-time" class="option-button" value="稼働時間に追加" /> </div> <div class="option-row table-box"> <table> <thead> <tr> <td>開始時間</td> <td>終了時間</td> <td></td> </tr> </thead> <tbody id="work-time-table"> <tr> <td>8:00</td> <td>17:00</td> <td> <span class="icon icon-delete">削除</span> </td> </tr> </tbody> </table> <div class="option-info valid">* 有効な書式: hh:mm</div> </div> <div class="option-row"> <input type="button" id="add-work-week" class="option-button" value="適用" /> </div> </div> </div> </div> </body> </html>
.clear-float:after { display: block; content: ""; clear: both; } .float-left { float: left; } .float-right { float: right; } .option-block { background: #fff; padding: 8px; margin: 12px 0; border-radius: 4px; border: 1px dashed #82bc00; box-shadow: 0px 0 6px 0 rgba(0,0,0,0.1); } .option-block.toggle { border: 1px dotted #f7a711; } .option-row { font-size: 14px; box-sizing: border-box; padding: 4px 0; } .option-title { font-weight: bold; color: #656565; } .option-info { font-size: 12px; color: #919191; margin-top: 6px; font-weight: normal; } .option-info.valid { color: #82bc00; } .option-info.toggle { color: #f7a711; } .option-button { width: 100%; padding: 0; line-height: 20px; background: #82bc00; color: #fff; transition: 0.3s; cursor: pointer; outline: none; border-radius: 4px; box-sizing: border-box; box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3); border: none; } .option-button:hover { background: #82bc00; color: #fff; box-shadow: 0 3px 8px 0 rgba(0,0,0,0.4); } .option-checkbox { background: #fff; border: 1px dashed #f7a711; color: #f7a711; padding: 2px 4px; transition: 0.3s; box-sizing: border-box; cursor: pointer; } .option-checkbox.active { color: #fff; background: #f7a711; box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3); border-radius: 4px; } .selection-box { position: relative; } .selection-box > select { text-align: left; width: 100%; height: 20px; padding: 0; line-height: 20px; background: transparent; border: none; border-bottom: 2px solid #656565; color: #656565; transition: 0.3s; cursor: pointer; outline: none; box-sizing: border-box; } .selection-box > select > option { background: white; } .selection-box > select:focus { border-bottom: 2px solid #82bc00; color: #82bc00; box-shadow: 0 2px 6px 0 rgba(0,0,0,0.3); } .selection-box > label { position: absolute; cursor: pointer; font-size: 12px; color: #fff; background: #656565; padding: 0 4px; right: 0; top: 6px; box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3); } .input-box { position: relative; } .input-box > input[type=text] { width: 100%; background: transparent; border: none; color: #656565; border-bottom: 2px solid #656565; outline: none; box-sizing: border-box; transition: 0.3s; } .input-box > input[type=text]:focus { color: #82bc00; border-bottom: 2px solid #82bc00; } .input-box > label { cursor: pointer; position: absolute; right: 0; top: 5px; font-size: 12px; color: #fff; background: #656565; padding: 0 4px; box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3); } .table-box > table { width: 100%; border-collapse: collapse; } .table-box > table > thead > tr { border-bottom: 1px solid #000; font-weight: bold; } .table-box > table > tbody > tr > td { margin-top: 8px; } .table-box .icon { padding: 0 2px; color: #fff; cursor: pointer; border: 1px solid #fff; border-radius: 3px; background: transparent; transition: 0.3s; } .table-box .icon:hover { color: #fff; box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3); } .icon.icon-edit { border-color: #82bc00; color: #82bc00; } .icon.icon-edit:hover { background: #82bc00; } .icon.icon-delete { border-color: #f7a711; color: #f7a711; } .icon.icon-delete:hover { background: #f7a711; } .input-date { width: 99px; border: none; border-bottom: 1px solid ; } .input-date { width: 99px; background: transparent; border: none; color: #656565; border-bottom: 2px solid #656565; outline: none; box-sizing: border-box; transition: 0.3s; } .input-date:focus { color: #82bc00; border-bottom: 2px solid #82bc00; }

デフォルトの週間稼働日数
週間稼働日数は7日間です。次のサンプルコードはデフォルトの週間稼働日数を取得します:
週間稼働日数の変更
次のサンプルコードは、稼働時間を変更します:
/*REPLACE_MARKER*/
/*DO NOT DELETE THESE COMMENTS*/
<template>
<div id="split-view" class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets split-content" @workbookInitialized="initSpread">
</gc-spread-sheets>
<div class="options-container split-panel">
<div class="option-row option-title">
稼働時間を設定します。
</div>
<div class="option-block">
<div class="option-row selection-box">
<label for="target-calendar">対象のカレンダー</label>
<select id="target-calendar">
<option value="standard" selected>標準</option>
<option value="hours24">24時間制</option>
<option value="nightShift">夜間シフト</option>
</select>
</div>
</div>
<div class="option-block toggle">
<div class="option-row option-title clear-float">
<span class="float-left">週間稼働詳細</span>
</div>
<div class="option-row selection-box">
<label for="target-day">稼働日</label>
<select id="target-day">
<option value="0" selected>日曜日</option>
<option value="1">月曜日</option>
<option value="2">火曜日</option>
<option value="3">水曜日</option>
<option value="4">木曜日</option>
<option value="5">金曜日</option>
<option value="6">土曜日</option>
</select>
</div>
<div class="option-row">
<input type="button" id="add-work-time" class="option-button" value="稼働時間に追加" />
</div>
<div class="option-row table-box">
<table>
<thead>
<tr>
<td>開始時間</td>
<td>終了時間</td>
<td></td>
</tr>
</thead>
<tbody id="work-time-table">
<tr>
<td>8:00</td>
<td>17:00</td>
<td>
<span class="icon icon-delete">削除</span>
</td>
</tr>
</tbody>
</table>
<div class="option-info valid">* 有効な書式: hh:mm</div>
</div>
<div class="option-row">
<input type="button" id="add-work-week" class="option-button" value="適用" />
</div>
</div>
</div>
</div>
</template>
<script setup>
import GC from "@mescius/spread-sheets";
import { ref } from "vue";
import "@mescius/spread-sheets-tablesheet";
import "@mescius/spread-sheets-ganttsheet";
import '@mescius/spread-sheets-resources-ja';
GC.Spread.Common.CultureManager.culture("ja-jp");
import "@mescius/spread-sheets-vue";
const spreadRef = ref(null);
let Calendars = {
standard: GC.Spread.Sheets.GanttSheet.Calendar.standard,
hours24: GC.Spread.Sheets.GanttSheet.Calendar.hours24,
nightShift: GC.Spread.Sheets.GanttSheet.Calendar.nightShift
};
let myTable = null;
let ganttSheet = GC.Spread.Sheets.GanttSheet;
let targetDay = "0";
let workingTimes = [];
let spread = null;
function initSpread(spread) {
spreadRef.value = spread;
spread.suspendPaint();
initDataSource(spread);
initGanttSheet(spread);
spread.resumePaint();
initSplitView(spread);
}
function initDataSource(spread) {
var tableName = "Gantt_Id";
var baseApiUrl = getBaseApiUrl();
var apiUrl = baseApiUrl + "/" + tableName;
var dataManager = spread.dataManager();
myTable = dataManager.addTable("myTable", {
batch: true,
remote: {
read: {
url: apiUrl
}
},
schema: {
hierarchy: {
type: "Parent",
column: "parentId"
},
columns: {
id: { isPrimaryKey: true },
taskNumber: { dataType: "rowOrder" }
}
}
});
};
function initGanttSheet(spread) {
ganttSheet = spread.addSheetTab(0, "GanttSheet", GC.Spread.Sheets.SheetType.ganttSheet);
var view = myTable.addView("ganttView", [
{ value: "taskNumber", caption: "NO.", width: 60 },
{ value: "name", caption: "Task Name", width: 200 },
{ value: "duration", caption: "Duration", width: 90 },
{ value: "predecessors", caption: "Predecessors", width: 120, visible: false }
]);
view.fetch().then(function () {
ganttSheet.bindGanttView(view);
ganttSheet.project.calendar = Calendars.standard;
});
initSidePanel(ganttSheet);
};
function initSidePanel(ganttSheet) {
var currentCustomWorkWeek = ganttSheet.project.calendar.defaultWorkWeek;
var targetCalendarItem = document.getElementById("target-calendar");
var customTargetDayItem = document.getElementById("target-day");
var addWorkTimeItem = document.getElementById("add-work-time");
var addWorkWeekItem = document.getElementById("add-work-week");
var workTimeTableItem = document.getElementById("work-time-table");
updateWorkingTimeTable(ganttSheet.project.calendar.defaultWorkWeek, 0);
targetCalendarItem.addEventListener("change", function () {
var calendarType = targetCalendarItem.value;
var calendar = Calendars[calendarType];
var workdayIndex = Number(customTargetDayItem.value);
currentCustomWorkWeek = calendar.defaultWorkWeek;
updateWorkingTimeTable(currentCustomWorkWeek, workdayIndex);
ganttSheet.project.calendar = calendar;
});
customTargetDayItem.addEventListener("change", function () {
var workdayIndex = Number(customTargetDayItem.value);
updateWorkingTimeTable(currentCustomWorkWeek, workdayIndex);
});
addWorkTimeItem.addEventListener("click", function () {
var workdayIndex = Number(customTargetDayItem.value);
var workday = currentCustomWorkWeek.getWorkDay(workdayIndex);
var workTime = { start: { hour: 0, minute: 0 }, end: { hour: 0, minute: 0 } };
workday.push(workTime);
updateWorkingTimeTable(currentCustomWorkWeek, workdayIndex);
});
workTimeTableItem.addEventListener("click", function (e) {
var target = e.target;
if (target.classList.contains("icon-delete")) {
var targetWorkTimeIndex = target.dataset.row;
var workdayIndex = Number(customTargetDayItem.value); // GC.Spread.Sheets.GanttSheet.DayOfWeek
var workday = currentCustomWorkWeek.getWorkDay(workdayIndex);
workday.splice(targetWorkTimeIndex, 1);
updateWorkingTimeTable(currentCustomWorkWeek, workdayIndex);
}
});
addWorkWeekItem.addEventListener("click", function () {
var calendar = ganttSheet.project.calendar;
var workdayIndex = Number(customTargetDayItem.value); // GC.Spread.Sheets.GanttSheet.DayOfWeek
var workday = currentCustomWorkWeek.getWorkDay(workdayIndex);
updateWorkingTime(workday);
calendar.defaultWorkWeek = currentCustomWorkWeek;
ganttSheet.project.calendar = calendar;
});
function updateWorkingTime(workday) {
var rows = workTimeTableItem.getElementsByTagName("tr");
if (rows) {
for (var i = 0; i < rows.length; i++) {
var row = rows[i];
var workTime = workday[i];
var startItemValue = row.getElementsByClassName("start-item")[0].value;
var endItemValue = row.getElementsByClassName("end-item")[0].value;
var start = parseTimeString(startItemValue);
var end = parseTimeString(endItemValue);
if (start) {
workTime.start = start;
}
if (end) {
workTime.end = end;
}
}
}
}
function updateWorkingTimeTable(customWorkWeeks, workdayIndex) {
var workday = customWorkWeeks.getWorkDay(workdayIndex);
var tableInnerHTML = "";
for (var i = 0; i < workday.length; i++) {
var workTime = workday[i];
var from = `${convertTimeString(workTime.start.hour)}:${convertTimeString(workTime.start.minute)}`;
var to = `${convertTimeString(workTime.end.hour)}:${convertTimeString(workTime.end.minute)}`;
var rowHTML = `
<tr>
<td><input type="text" class="input-date start-item" value="${from}" /></td>
<td><input type="text" class="input-date end-item" value="${to}" /></td>
${getTableFunctionalColumn(false, true, i)}
</tr>
`;
tableInnerHTML += rowHTML;
}
workTimeTableItem.innerHTML = tableInnerHTML;
}
function getTableFunctionalColumn(needEdit, needDelete, index) {
return `
<td>
${needEdit ? `<span class="icon icon-edit" ${typeof index === "number" ? "data-row=" + index : ""}>edit</span>` : ""}
${needDelete ? `<span class="icon icon-delete" ${typeof index === "number" ? "data-row=" + index : ""}>削除</span>` : ""}
</td>
`;
}
function convertTimeString(num) {
if (num < 10) {
return "0" + num;
}
else {
return num.toString();
}
}
function parseTimeString(timeString) {
var hourAndMinute = timeString.split(":");
if (hourAndMinute && hourAndMinute.length === 2) {
return { hour: Number(hourAndMinute[0]), minute: Number(hourAndMinute[1]) };
}
}
}
function getBaseApiUrl() {
return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api';
}
function initSplitView(spread) {
var host = document.getElementById("split-view");
var content = host.getElementsByClassName("split-content")[0];
var panel = host.getElementsByClassName("split-panel")[0];
var defaultPanelWidth = 340;
new SplitView({
host: host,
content: content,
panel: panel,
defaultPanelWidth: defaultPanelWidth,
refreshContent: function () {
spread.refresh();
}
});
}
</script>
<style scoped>
#app {
height: 100%;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: 100%;
height: 100%;
overflow: hidden;
float: left;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
.clear-float:after {
display: block;
content: "";
clear: both;
}
.float-left {
float: left;
}
.float-right {
float: right;
}
.option-block {
background: #fff;
padding: 8px;
margin: 12px 0;
border-radius: 4px;
border: 1px dashed #82bc00;
box-shadow: 0px 0 6px 0 rgba(0, 0, 0, 0.1);
}
.option-block.toggle {
border: 1px dotted #f7a711;
}
.option-row {
font-size: 14px;
box-sizing: border-box;
padding: 4px 0;
}
.option-title {
font-weight: bold;
color: #656565;
}
.option-info {
font-size: 12px;
color: #919191;
margin-top: 6px;
font-weight: normal;
}
.option-info.valid {
color: #82bc00;
}
.option-info.toggle {
color: #f7a711;
}
.option-button {
width: 100%;
padding: 0;
line-height: 20px;
background: #82bc00;
color: #fff;
transition: 0.3s;
cursor: pointer;
outline: none;
border-radius: 4px;
box-sizing: border-box;
box-shadow: 0 1px 4px 0 rgba(0, 0, 0, 0.3);
border: none;
}
.option-button:hover {
background: #82bc00;
color: #fff;
box-shadow: 0 3px 8px 0 rgba(0, 0, 0, 0.4);
}
.option-checkbox {
background: #fff;
border: 1px dashed #f7a711;
color: #f7a711;
padding: 2px 4px;
transition: 0.3s;
box-sizing: border-box;
cursor: pointer;
}
.option-checkbox.active {
color: #fff;
background: #f7a711;
box-shadow: 0 1px 4px 0 rgba(0, 0, 0, 0.3);
border-radius: 4px;
}
.selection-box {
position: relative;
}
.selection-box>select {
text-align: left;
width: 100%;
height: 20px;
padding: 0;
line-height: 20px;
background: transparent;
border: none;
border-bottom: 2px solid #656565;
color: #656565;
transition: 0.3s;
cursor: pointer;
outline: none;
box-sizing: border-box;
}
.selection-box>select>option {
background: white;
}
.selection-box>select:focus {
border-bottom: 2px solid #82bc00;
color: #82bc00;
box-shadow: 0 2px 6px 0 rgba(0, 0, 0, 0.3);
}
.selection-box>label {
position: absolute;
cursor: pointer;
font-size: 12px;
color: #fff;
background: #656565;
padding: 0 4px;
right: 0;
top: 6px;
box-shadow: 0 1px 4px 0 rgba(0, 0, 0, 0.3);
}
.input-box {
position: relative;
}
.input-box>input[type=text] {
width: 100%;
background: transparent;
border: none;
color: #656565;
border-bottom: 2px solid #656565;
outline: none;
box-sizing: border-box;
transition: 0.3s;
}
.input-box>input[type=text]:focus {
color: #82bc00;
border-bottom: 2px solid #82bc00;
}
.input-box>label {
cursor: pointer;
position: absolute;
right: 0;
top: 5px;
font-size: 12px;
color: #fff;
background: #656565;
padding: 0 4px;
box-shadow: 0 1px 4px 0 rgba(0, 0, 0, 0.3);
}
.table-box>table {
width: 100%;
border-collapse: collapse;
}
.table-box>table>thead>tr {
border-bottom: 1px solid #000;
font-weight: bold;
}
.table-box>table>tbody>tr>td {
margin-top: 8px;
}
.table-box .icon {
padding: 0 2px;
color: #fff;
cursor: pointer;
border: 1px solid #fff;
border-radius: 3px;
background: transparent;
transition: 0.3s;
}
.table-box .icon:hover {
color: #fff;
box-shadow: 0 1px 4px 0 rgba(0, 0, 0, 0.3);
}
.icon.icon-edit {
border-color: #82bc00;
color: #82bc00;
}
.icon.icon-edit:hover {
background: #82bc00;
}
.icon.icon-delete {
border-color: #f7a711;
color: #f7a711;
}
.icon.icon-delete:hover {
background: #f7a711;
}
.input-date {
width: 100%;
border: none;
border-bottom: 1px solid;
}
.input-date {
width: 100%;
background: transparent;
border: none;
color: #656565;
border-bottom: 2px solid #656565;
outline: none;
box-sizing: border-box;
transition: 0.3s;
}
.input-date:focus {
color: #82bc00;
border-bottom: 2px solid #82bc00;
}
</style>
<!DOCTYPE html>
<html lang="en" style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/ja/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/spread/source/splitView/splitView.css">
<script src="$DEMOROOT$/ja/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script src="$DEMOROOT$/spread/source/splitView/SplitView.js"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/ja/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-ja': 'npm:@mescius/spread-sheets-resources-ja/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js',
'@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js',
'@mescius/spread-sheets-ganttsheet': 'npm:@mescius/spread-sheets-ganttsheet/index.js'
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

デフォルトの週間稼働日数
週間稼働日数は7日間です。次のサンプルコードはデフォルトの週間稼働日数を取得します:
週間稼働日数の変更
次のサンプルコードは、稼働時間を変更します:
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
ReactDOM.render(<AppFunc />, document.getElementById('app'));
// 2. Class Component sample
// ReactDOM.render(<App />, document.getElementById('app'));
/*REPLACE_MARKER*/
/*DO NOT DELETE THESE COMMENTS*/
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-tablesheet";
import "@mescius/spread-sheets-ganttsheet";
import '@mescius/spread-sheets-resources-ja';
GC.Spread.Common.CultureManager.culture("ja-jp");
import { SpreadSheets } from '@mescius/spread-sheets-react';
import './styles.css';
var Calendars = {
standard: GC.Spread.Sheets.GanttSheet.Calendar.standard,
hours24: GC.Spread.Sheets.GanttSheet.Calendar.hours24,
nightShift: GC.Spread.Sheets.GanttSheet.Calendar.nightShift
};
let myTable = null;
export function AppFunc() {
const initSpread = (spread) => {
spread.suspendPaint();
initDataSource(spread);
initGanttSheet(spread);
spread.resumePaint();
initSplitView(spread)
}
const initDataSource = (spread) => {
var tableName = "Gantt_Id";
var baseApiUrl = getBaseApiUrl();
var apiUrl = baseApiUrl + "/" + tableName;
var dataManager = spread.dataManager();
myTable = dataManager.addTable("myTable", {
batch: true,
remote: {
read: {
url: apiUrl
}
},
schema: {
hierarchy: {
type: "Parent",
column: "parentId"
},
columns: {
id: { isPrimaryKey: true },
taskNumber: { dataType: "rowOrder" }
}
}
});
}
const initGanttSheet = (spread) => {
var ganttSheet = spread.addSheetTab(0, "GanttSheet", GC.Spread.Sheets.SheetType.ganttSheet);
var view = myTable.addView("ganttView", [
{ value: "taskNumber", caption: "NO.", width: 60 },
{ value: "name", caption: "Task Name", width: 200 },
{ value: "duration", caption: "Duration", width: 90 },
{ value: "predecessors", caption: "Predecessors", width: 120, visible: false }
]);
view.fetch().then(function () {
ganttSheet.bindGanttView(view);
ganttSheet.project.calendar = Calendars.standard;
});
initSidePanel(ganttSheet);
}
const initSidePanel = (ganttSheet) => {
var currentCustomWorkWeek = ganttSheet.project.calendar.defaultWorkWeek;
var targetCalendarItem = document.getElementById("target-calendar");
var customTargetDayItem = document.getElementById("target-day");
var addWorkTimeItem = document.getElementById("add-work-time");
var addWorkWeekItem = document.getElementById("add-work-week");
var workTimeTableItem = document.getElementById("work-time-table");
updateWorkingTimeTable(ganttSheet.project.calendar.defaultWorkWeek, 0);
targetCalendarItem.addEventListener("change", function () {
var calendarType = targetCalendarItem.value;
var calendar = Calendars[calendarType];
var workdayIndex = Number(customTargetDayItem.value);
currentCustomWorkWeek = calendar.defaultWorkWeek;
updateWorkingTimeTable(currentCustomWorkWeek, workdayIndex);
ganttSheet.project.calendar = calendar;
});
customTargetDayItem.addEventListener("change", function () {
var workdayIndex = Number(customTargetDayItem.value);
updateWorkingTimeTable(currentCustomWorkWeek, workdayIndex);
});
addWorkTimeItem.addEventListener("click", function () {
var workdayIndex = Number(customTargetDayItem.value);
var workday = currentCustomWorkWeek.getWorkDay(workdayIndex);
var workTime = { start: { hour: 0, minute: 0 }, end: { hour: 0, minute: 0 } };
workday.push(workTime);
updateWorkingTimeTable(currentCustomWorkWeek, workdayIndex);
});
workTimeTableItem.addEventListener("click", function (e) {
var target = e.target;
if (target.classList.contains("icon-delete")) {
var targetWorkTimeIndex = target.dataset.row;
var workdayIndex = Number(customTargetDayItem.value); // GC.Spread.Sheets.GanttSheet.DayOfWeek
var workday = currentCustomWorkWeek.getWorkDay(workdayIndex);
workday.splice(targetWorkTimeIndex, 1);
updateWorkingTimeTable(currentCustomWorkWeek, workdayIndex);
}
});
addWorkWeekItem.addEventListener("click", function () {
var calendar = ganttSheet.project.calendar;
var workdayIndex = Number(customTargetDayItem.value); // GC.Spread.Sheets.GanttSheet.DayOfWeek
var workday = currentCustomWorkWeek.getWorkDay(workdayIndex);
updateWorkingTime(workday);
calendar.defaultWorkWeek = currentCustomWorkWeek;
ganttSheet.project.calendar = calendar;
});
function updateWorkingTime(workday) {
var rows = workTimeTableItem.getElementsByTagName("tr");
if (rows) {
for (var i = 0; i < rows.length; i++) {
var row = rows[i];
var workTime = workday[i];
var startItemValue = row.getElementsByClassName("start-item")[0].value;
var endItemValue = row.getElementsByClassName("end-item")[0].value;
var start = parseTimeString(startItemValue);
var end = parseTimeString(endItemValue);
if (start) {
workTime.start = start;
}
if (end) {
workTime.end = end;
}
}
}
}
function updateWorkingTimeTable(customWorkWeeks, workdayIndex) {
var workday = customWorkWeeks.getWorkDay(workdayIndex);
var tableInnerHTML = "";
for (var i = 0; i < workday.length; i++) {
var workTime = workday[i];
var from = `${convertTimeString(workTime.start.hour)}:${convertTimeString(workTime.start.minute)}`;
var to = `${convertTimeString(workTime.end.hour)}:${convertTimeString(workTime.end.minute)}`;
var rowHTML = `
<tr>
<td><input type="text" class="input-date start-item" value="${from}" /></td>
<td><input type="text" class="input-date end-item" value="${to}" /></td>
${getTableFunctionalColumn(false, true, i)}
</tr>
`;
tableInnerHTML += rowHTML;
}
workTimeTableItem.innerHTML = tableInnerHTML;
}
function getTableFunctionalColumn(needEdit, needDelete, index) {
return `
<td>
${needEdit ? `<span class="icon icon-edit" ${typeof index === "number" ? "data-row=" + index : ""}>edit</span>` : ""}
${needDelete ? `<span class="icon icon-delete" ${typeof index === "number" ? "data-row=" + index : ""}>削除</span>` : ""}
</td>
`;
}
function convertTimeString(num) {
if (num < 10) {
return "0" + num;
}
else {
return num.toString();
}
}
function parseTimeString(timeString) {
var hourAndMinute = timeString.split(":");
if (hourAndMinute && hourAndMinute.length === 2) {
return { hour: Number(hourAndMinute[0]), minute: Number(hourAndMinute[1]) };
}
}
}
return (
<div id="split-view" class="sample-tutorial">
<div class="sample-spreadsheets split-content">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}></SpreadSheets>
</div>
<div class="options-container split-panel">
<div class="option-row option-title">
稼働時間を設定します。
</div>
<div class="option-block">
<div class="option-row selection-box">
<label for="target-calendar">対象のカレンダー</label>
<select id="target-calendar">
<option value="standard" selected>標準</option>
<option value="hours24">24時間制</option>
<option value="nightShift">夜間シフト</option>
</select>
</div>
</div>
<div class="option-block toggle">
<div class="option-row option-title clear-float">
<span class="float-left">週間稼働詳細</span>
</div>
<div class="option-row selection-box">
<label for="target-day">稼働日</label>
<select id="target-day">
<option value="0" selected>日曜日</option>
<option value="1">月曜日</option>
<option value="2">火曜日</option>
<option value="3">水曜日</option>
<option value="4">木曜日</option>
<option value="5">金曜日</option>
<option value="6">土曜日</option>
</select>
</div>
<div class="option-row">
<input type="button" id="add-work-time" class="option-button" value="稼働時間に追加" />
</div>
<div class="option-row table-box">
<table>
<thead>
<tr>
<td>開始時間</td>
<td>終了時間</td>
<td></td>
</tr>
</thead>
<tbody id="work-time-table">
<tr>
<td>8:00</td>
<td>17:00</td>
<td>
<span class="icon icon-delete">削除</span>
</td>
</tr>
</tbody>
</table>
<div class="option-info valid">* 有効な書式: hh:mm</div>
</div>
<div class="option-row">
<input type="button" id="add-work-week" class="option-button" value="適用" />
</div>
</div>
</div>
</div>
);
}
function initSplitView(spread) {
var host = document.getElementById("split-view");
var content = host.getElementsByClassName("split-content")[0];
var panel = host.getElementsByClassName("split-panel")[0];
new SplitView({
host: host,
content: content,
panel: panel,
refreshContent: function () {
spread.refresh();
}
});
}
function getBaseApiUrl() {
return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api';
}
/*REPLACE_MARKER*/
/*DO NOT DELETE THESE COMMENTS*/
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-tablesheet";
import "@mescius/spread-sheets-ganttsheet";
import '@mescius/spread-sheets-resources-ja';
GC.Spread.Common.CultureManager.culture("ja-jp");
import { SpreadSheets } from '@mescius/spread-sheets-react';
import './styles.css';
const Component = React.Component;
var Calendars = {
standard: GC.Spread.Sheets.GanttSheet.Calendar.standard,
hours24: GC.Spread.Sheets.GanttSheet.Calendar.hours24,
nightShift: GC.Spread.Sheets.GanttSheet.Calendar.nightShift
};
export class App extends Component {
render() {
return (
<div id="split-view" class="sample-tutorial">
<div class="sample-spreadsheets split-content">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}></SpreadSheets>
</div>
<div class="options-container split-panel">
<div class="option-row option-title">
稼働時間を設定します。
</div>
<div class="option-block">
<div class="option-row selection-box">
<label for="target-calendar">対象のカレンダー</label>
<select id="target-calendar">
<option value="standard" selected>標準</option>
<option value="hours24">24時間制</option>
<option value="nightShift">夜間シフト</option>
</select>
</div>
</div>
<div class="option-block toggle">
<div class="option-row option-title clear-float">
<span class="float-left">週間稼働詳細</span>
</div>
<div class="option-row selection-box">
<label for="target-day">稼働日</label>
<select id="target-day">
<option value="0" selected>日曜日</option>
<option value="1">月曜日</option>
<option value="2">火曜日</option>
<option value="3">水曜日</option>
<option value="4">木曜日</option>
<option value="5">金曜日</option>
<option value="6">土曜日</option>
</select>
</div>
<div class="option-row">
<input type="button" id="add-work-time" class="option-button" value="稼働時間に追加" />
</div>
<div class="option-row table-box">
<table>
<thead>
<tr>
<td>開始時間</td>
<td>終了時間</td>
<td></td>
</tr>
</thead>
<tbody id="work-time-table">
<tr>
<td>8:00</td>
<td>17:00</td>
<td>
<span class="icon icon-delete">削除</span>
</td>
</tr>
</tbody>
</table>
<div class="option-info valid">* 有効な書式: hh:mm</div>
</div>
<div class="option-row">
<input type="button" id="add-work-week" class="option-button" value="適用" />
</div>
</div>
</div>
</div>
);
}
initSpread(spread) {
spread.suspendPaint();
this.initDataSource(spread);
this.initGanttSheet(spread);
spread.resumePaint();
initSplitView(spread)
}
initDataSource(spread) {
var tableName = "Gantt_Id";
var baseApiUrl = getBaseApiUrl();
var apiUrl = baseApiUrl + "/" + tableName;
var dataManager = spread.dataManager();
var myTable = dataManager.addTable("myTable", {
batch: true,
remote: {
read: {
url: apiUrl
}
},
schema: {
hierarchy: {
type: "Parent",
column: "parentId"
},
columns: {
id: { isPrimaryKey: true },
taskNumber: { dataType: "rowOrder" }
}
}
});
this.myTable = myTable;
}
initGanttSheet(spread) {
var ganttSheet = spread.addSheetTab(0, "GanttSheet", GC.Spread.Sheets.SheetType.ganttSheet);
var view = this.myTable.addView("ganttView", [
{ value: "taskNumber", caption: "NO.", width: 60 },
{ value: "name", caption: "Task Name", width: 200 },
{ value: "duration", caption: "Duration", width: 90 },
{ value: "predecessors", caption: "Predecessors", width: 120, visible: false }
]);
view.fetch().then(function () {
ganttSheet.bindGanttView(view);
ganttSheet.project.calendar = Calendars.standard;
});
this.initSidePanel(ganttSheet);
}
initSidePanel(ganttSheet) {
var currentCustomWorkWeek = ganttSheet.project.calendar.defaultWorkWeek;
var targetCalendarItem = document.getElementById("target-calendar");
var customTargetDayItem = document.getElementById("target-day");
var addWorkTimeItem = document.getElementById("add-work-time");
var addWorkWeekItem = document.getElementById("add-work-week");
var workTimeTableItem = document.getElementById("work-time-table");
updateWorkingTimeTable(ganttSheet.project.calendar.defaultWorkWeek, 0);
targetCalendarItem.addEventListener("change", function () {
var calendarType = targetCalendarItem.value;
var calendar = Calendars[calendarType];
var workdayIndex = Number(customTargetDayItem.value);
currentCustomWorkWeek = calendar.defaultWorkWeek;
updateWorkingTimeTable(currentCustomWorkWeek, workdayIndex);
ganttSheet.project.calendar = calendar;
});
customTargetDayItem.addEventListener("change", function () {
var workdayIndex = Number(customTargetDayItem.value);
updateWorkingTimeTable(currentCustomWorkWeek, workdayIndex);
});
addWorkTimeItem.addEventListener("click", function () {
var workdayIndex = Number(customTargetDayItem.value);
var workday = currentCustomWorkWeek.getWorkDay(workdayIndex);
var workTime = { start: { hour: 0, minute: 0 }, end: { hour: 0, minute: 0 } };
workday.push(workTime);
updateWorkingTimeTable(currentCustomWorkWeek, workdayIndex);
});
workTimeTableItem.addEventListener("click", function (e) {
var target = e.target;
if (target.classList.contains("icon-delete")) {
var targetWorkTimeIndex = target.dataset.row;
var workdayIndex = Number(customTargetDayItem.value); // GC.Spread.Sheets.GanttSheet.DayOfWeek
var workday = currentCustomWorkWeek.getWorkDay(workdayIndex);
workday.splice(targetWorkTimeIndex, 1);
updateWorkingTimeTable(currentCustomWorkWeek, workdayIndex);
}
});
addWorkWeekItem.addEventListener("click", function () {
var calendar = ganttSheet.project.calendar;
var workdayIndex = Number(customTargetDayItem.value); // GC.Spread.Sheets.GanttSheet.DayOfWeek
var workday = currentCustomWorkWeek.getWorkDay(workdayIndex);
updateWorkingTime(workday);
calendar.defaultWorkWeek = currentCustomWorkWeek;
ganttSheet.project.calendar = calendar;
});
function updateWorkingTime(workday) {
var rows = workTimeTableItem.getElementsByTagName("tr");
if (rows) {
for (var i = 0; i < rows.length; i++) {
var row = rows[i];
var workTime = workday[i];
var startItemValue = row.getElementsByClassName("start-item")[0].value;
var endItemValue = row.getElementsByClassName("end-item")[0].value;
var start = parseTimeString(startItemValue);
var end = parseTimeString(endItemValue);
if (start) {
workTime.start = start;
}
if (end) {
workTime.end = end;
}
}
}
}
function updateWorkingTimeTable(customWorkWeeks, workdayIndex) {
var workday = customWorkWeeks.getWorkDay(workdayIndex);
var tableInnerHTML = "";
for (var i = 0; i < workday.length; i++) {
var workTime = workday[i];
var from = `${convertTimeString(workTime.start.hour)}:${convertTimeString(workTime.start.minute)}`;
var to = `${convertTimeString(workTime.end.hour)}:${convertTimeString(workTime.end.minute)}`;
var rowHTML = `
<tr>
<td><input type="text" class="input-date start-item" value="${from}" /></td>
<td><input type="text" class="input-date end-item" value="${to}" /></td>
${getTableFunctionalColumn(false, true, i)}
</tr>
`;
tableInnerHTML += rowHTML;
}
workTimeTableItem.innerHTML = tableInnerHTML;
}
function getTableFunctionalColumn(needEdit, needDelete, index) {
return `
<td>
${needEdit ? `<span class="icon icon-edit" ${typeof index === "number" ? "data-row=" + index : ""}>edit</span>` : ""}
${needDelete ? `<span class="icon icon-delete" ${typeof index === "number" ? "data-row=" + index : ""}>削除</span>` : ""}
</td>
`;
}
function convertTimeString(num) {
if (num < 10) {
return "0" + num;
}
else {
return num.toString();
}
}
function parseTimeString(timeString) {
var hourAndMinute = timeString.split(":");
if (hourAndMinute && hourAndMinute.length === 2) {
return { hour: Number(hourAndMinute[0]), minute: Number(hourAndMinute[1]) };
}
}
}
}
function initSplitView(spread) {
var host = document.getElementById("split-view");
var content = host.getElementsByClassName("split-content")[0];
var panel = host.getElementsByClassName("split-panel")[0];
new SplitView({
host: host,
content: content,
panel: panel,
refreshContent: function () {
spread.refresh();
}
});
}
function getBaseApiUrl() {
return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api';
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/ja/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/spread/source/splitView/splitView.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/ja/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<!-- plugins -->
<script src="$DEMOROOT$/spread/source/splitView/SplitView.js"></script>
<script src="$DEMOROOT$/spread/source/js/FileSaver.js" type="text/javascript"></script>
<script>
System.import('$DEMOROOT$/ja/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app" style="height: 100%;"></div>
</body>
</html>
.clear-float:after {
display: block;
content: "";
clear: both;
}
.float-left {
float: left;
}
.float-right {
float: right;
}
.option-block {
background: #fff;
padding: 8px;
margin: 12px 0;
border-radius: 4px;
border: 1px dashed #82bc00;
box-shadow: 0px 0 6px 0 rgba(0,0,0,0.1);
}
.option-block.toggle {
border: 1px dotted #f7a711;
}
.option-row {
font-size: 14px;
box-sizing: border-box;
padding: 4px 0;
}
.option-title {
font-weight: bold;
color: #656565;
}
.option-info {
font-size: 12px;
color: #919191;
margin-top: 6px;
font-weight: normal;
}
.option-info.valid {
color: #82bc00;
}
.option-info.toggle {
color: #f7a711;
}
.option-button {
width: 100%;
padding: 0;
line-height: 20px;
background: #82bc00;
color: #fff;
transition: 0.3s;
cursor: pointer;
outline: none;
border-radius: 4px;
box-sizing: border-box;
box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3);
border: none;
}
.option-button:hover {
background: #82bc00;
color: #fff;
box-shadow: 0 3px 8px 0 rgba(0,0,0,0.4);
}
.option-checkbox {
background: #fff;
border: 1px dashed #f7a711;
color: #f7a711;
padding: 2px 4px;
transition: 0.3s;
box-sizing: border-box;
cursor: pointer;
}
.option-checkbox.active {
color: #fff;
background: #f7a711;
box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3);
border-radius: 4px;
}
.selection-box {
position: relative;
}
.selection-box > select {
text-align: left;
width: 100%;
height: 20px;
padding: 0;
line-height: 20px;
background: transparent;
border: none;
border-bottom: 2px solid #656565;
color: #656565;
transition: 0.3s;
cursor: pointer;
outline: none;
box-sizing: border-box;
}
.selection-box > select > option {
background: white;
}
.selection-box > select:focus {
border-bottom: 2px solid #82bc00;
color: #82bc00;
box-shadow: 0 2px 6px 0 rgba(0,0,0,0.3);
}
.selection-box > label {
position: absolute;
cursor: pointer;
font-size: 12px;
color: #fff;
background: #656565;
padding: 0 4px;
right: 0;
top: 6px;
box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3);
}
.input-box {
position: relative;
}
.input-box > input[type=text] {
width: 100%;
background: transparent;
border: none;
color: #656565;
border-bottom: 2px solid #656565;
outline: none;
box-sizing: border-box;
transition: 0.3s;
}
.input-box > input[type=text]:focus {
color: #82bc00;
border-bottom: 2px solid #82bc00;
}
.input-box > label {
cursor: pointer;
position: absolute;
right: 0;
top: 5px;
font-size: 12px;
color: #fff;
background: #656565;
padding: 0 4px;
box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3);
}
.table-box > table {
width: 100%;
border-collapse: collapse;
}
.table-box > table > thead > tr {
border-bottom: 1px solid #000;
font-weight: bold;
}
.table-box > table > tbody > tr > td {
margin-top: 8px;
}
.table-box .icon {
padding: 0 2px;
color: #fff;
cursor: pointer;
border: 1px solid #fff;
border-radius: 3px;
background: transparent;
transition: 0.3s;
}
.table-box .icon:hover {
color: #fff;
box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3);
}
.icon.icon-edit {
border-color: #82bc00;
color: #82bc00;
}
.icon.icon-edit:hover {
background: #82bc00;
}
.icon.icon-delete {
border-color: #f7a711;
color: #f7a711;
}
.icon.icon-delete:hover {
background: #f7a711;
}
.input-date {
width: 99px;
border: none;
border-bottom: 1px solid ;
}
.input-date {
width: 99px;
background: transparent;
border: none;
color: #656565;
border-bottom: 2px solid #656565;
outline: none;
box-sizing: border-box;
transition: 0.3s;
}
.input-date:focus {
color: #82bc00;
border-bottom: 2px solid #82bc00;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-ja': 'npm:@mescius/spread-sheets-resources-ja/index.js',
'@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js',
'@mescius/spread-sheets-ganttsheet': 'npm:@mescius/spread-sheets-ganttsheet/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/umd/react.production.min.js',
'react-dom': 'npm:react-dom/umd/react-dom.production.min.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

デフォルトの週間稼働日数
週間稼働日数は7日間です。次のサンプルコードはデフォルトの週間稼働日数を取得します:
週間稼働日数の変更
次のサンプルコードは、稼働時間を変更します:
/*REPLACE_MARKER*/
/*DO NOT DELETE THESE COMMENTS*/
import { Component, NgModule, enableProdMode } from '@angular/core';
import { bootstrapApplication, BrowserModule } from '@angular/platform-browser';
import { FormsModule } from "@angular/forms";
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-tablesheet";
import "@mescius/spread-sheets-ganttsheet";
import '@mescius/spread-sheets-resources-ja';
GC.Spread.Common.CultureManager.culture("ja-jp");
import './styles.css';
declare var SplitView: any;
var Calendars = {
standard: GC.Spread.Sheets.GanttSheet.Calendar.standard,
hours24: GC.Spread.Sheets.GanttSheet.Calendar.hours24,
nightShift: GC.Spread.Sheets.GanttSheet.Calendar.nightShift
};
@Component({
standalone: true,
imports: [SpreadSheetsModule, BrowserModule, FormsModule],
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
ganttSheet: GC.Spread.Sheets.GanttSheet;
targetCalendarType = "standard";
targetDay = "0";
workingTimes = [];
hostStyle = {
width: '100%',
height: '100%'
};
initSpread($event: any) {
this.spread = $event.spread;
let spread = this.spread;
spread.suspendPaint();
spread.clearSheets();
this.initDataSource(spread);
this.initGanttSheet(spread);
spread.resumePaint();
initSplitView(spread);
}
initDataSource(spread) {
var tableName = "Gantt_Id";
var baseApiUrl = getBaseApiUrl();
var apiUrl = baseApiUrl + "/" + tableName;
var dataManager = spread.dataManager();
var myTable = dataManager.addTable("myTable", {
batch: true,
remote: {
read: {
url: apiUrl
}
},
schema: {
hierarchy: {
type: "Parent",
column: "parentId"
},
columns: {
id: { isPrimaryKey: true },
taskNumber: { dataType: "rowOrder" }
}
}
});
this.myTable = myTable;
}
initGanttSheet(spread) {
var ganttSheet = spread.addSheetTab(0, "GanttSheet", GC.Spread.Sheets.SheetType.ganttSheet);
var view = this.myTable.addView("ganttView", [
{ value: "taskNumber", caption: "NO.", width: 60 },
{ value: "name", caption: "Task Name", width: 200 },
{ value: "duration", caption: "Duration", width: 90 },
{ value: "predecessors", caption: "Predecessors", width: 120, visible: false }
]);
view.fetch().then(() => {
ganttSheet.bindGanttView(view);
ganttSheet.project.calendar = Calendars.standard;
});
this.ganttSheet = ganttSheet;
this.workingTimes = this.getWorkingTimes();
}
getTime(workingTime, type) {
return `${convertTimeString(workingTime[type].hour)}:${convertTimeString(workingTime[type].minute)}`;
}
updateTime(e, workingTime, type) {
var time = parseTimeString(e.target.value);
workingTime[type].hour = time.hour;
workingTime[type].minute = time.minute;
}
onTargetCalendarChanged() {
var calendarType = this.targetCalendarType;
var calendar = Calendars[calendarType];
this.ganttSheet.project.calendar = calendar;
this.workingTimes = this.getWorkingTimes();
}
onTargetDayChanged() {
this.workingTimes = this.getWorkingTimes();
}
addWorkingTime() {
var workTime = { start: { hour: 0, minute: 0 }, end: { hour: 0, minute: 0 } };
this.workingTimes.push(workTime);
}
removeWorkingTime(index) {
this.workingTimes.splice(index, 1);
}
getWorkingTimes() {
var ganttSheet = this.ganttSheet;
if (!ganttSheet) {
return [];
}
var workdayIndex = Number(this.targetDay);
return [...this.ganttSheet.project.calendar.defaultWorkWeek.getWorkDay(workdayIndex)];
}
applyCalendar() {
var ganttSheet = this.ganttSheet;
var calendar = ganttSheet.project.calendar;
var workdayIndex = Number(this.targetDay);
var defaultWorkWeek = calendar.defaultWorkWeek;
var actualWorkingTimes = defaultWorkWeek.getWorkDay(workdayIndex);
actualWorkingTimes.length = 0;
for (let i = 0; i < this.workingTimes.length; i++) {
actualWorkingTimes[i] = this.workingTimes[i];
}
calendar.defaultWorkWeek = defaultWorkWeek;
ganttSheet.project.calendar = calendar;
}
}
function convertTimeString(num) {
if (num < 10) {
return "0" + num;
}
else {
return num.toString();
}
}
function parseTimeString(timeString) {
var hourAndMinute = timeString.split(":");
if (hourAndMinute && hourAndMinute.length === 2) {
return { hour: Number(hourAndMinute[0]), minute: Number(hourAndMinute[1]) };
}
}
function initSplitView(spread) {
var host = document.getElementById("split-view");
var content = host.getElementsByClassName("split-content")[0];
var panel = host.getElementsByClassName("split-panel")[0];
new SplitView({
host: host,
content: content,
panel: panel,
refreshContent: function() {
spread.refresh();
}
});
}
function getBaseApiUrl() {
return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api';
}
enableProdMode();
bootstrapApplication(AppComponent);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/ja/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/spread/source/splitView/splitView.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/ja/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/ja/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/ja/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<!-- plugins -->
<script src="$DEMOROOT$/spread/source/splitView/SplitView.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/ja/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div id="split-view" class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets split-content" [hostStyle]="hostStyle"
(workbookInitialized)="initSpread($event)"></gc-spread-sheets>
<div class="options-container split-panel">
<div class="option-row option-title">
稼働時間を設定します。
</div>
<div class="option-block">
<div class="option-row selection-box">
<label for="target-calendar">対象のカレンダー</label>
<select id="target-calendar" [(ngModel)]="targetCalendarType" (change)="onTargetCalendarChanged()">
<option value="standard" selected>標準</option>
<option value="hours24">24時間制</option>
<option value="nightShift">夜間シフト</option>
</select>
</div>
</div>
<div class="option-block toggle">
<div class="option-row option-title clear-float">
<span class="float-left">週間稼働詳細</span>
</div>
<div class="option-row selection-box">
<label for="target-day">稼働日</label>
<select id="target-day" [(ngModel)]="targetDay" (change)="onTargetDayChanged()">
<option value="0" selected>日曜日</option>
<option value="1">月曜日</option>
<option value="2">火曜日</option>
<option value="3">水曜日</option>
<option value="4">木曜日</option>
<option value="5">金曜日</option>
<option value="6">土曜日</option>
</select>
</div>
<div class="option-row">
<input type="button" id="add-work-time" class="option-button" value="稼働時間に追加"
(click)="addWorkingTime()" />
</div>
<div class="option-row table-box">
<table>
<thead>
<tr>
<td>開始時間</td>
<td>終了時間</td>
<td></td>
</tr>
</thead>
<tbody id="work-time-table">
<tr *ngFor="let item of workingTimes, index">
<td><input type="text" class="input-date start-item" [value]="getTime(item, 'start')"
(change)="updateTime($event, item, 'start')" /></td>
<td><input type="text" class="input-date start-item" [value]="getTime(item, 'end')"
(change)="updateTime($event, item, 'end')" /></td>
<td>
<span class="icon icon-delete" (click)="removeWorkingTime(index)">削除</span>
</td>
</tr>
</tbody>
</table>
<div class="option-info valid">* 有効な書式: hh:mm</div>
</div>
<div class="option-row">
<input type="button" id="add-work-week" class="option-button" value="適用" (click)="applyCalendar()" />
</div>
</div>
</div>
</div>
.clear-float:after {
display: block;
content: "";
clear: both;
}
.float-left {
float: left;
}
.float-right {
float: right;
}
.option-block {
background: #fff;
padding: 8px;
margin: 12px 0;
border-radius: 4px;
border: 1px dashed #82bc00;
box-shadow: 0px 0 6px 0 rgba(0,0,0,0.1);
}
.option-block.toggle {
border: 1px dotted #f7a711;
}
.option-row {
font-size: 14px;
box-sizing: border-box;
padding: 4px 0;
}
.option-title {
font-weight: bold;
color: #656565;
}
.option-info {
font-size: 12px;
color: #919191;
margin-top: 6px;
font-weight: normal;
}
.option-info.valid {
color: #82bc00;
}
.option-info.toggle {
color: #f7a711;
}
.option-button {
width: 100%;
padding: 0;
line-height: 20px;
background: #82bc00;
color: #fff;
transition: 0.3s;
cursor: pointer;
outline: none;
border-radius: 4px;
box-sizing: border-box;
box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3);
border: none;
}
.option-button:hover {
background: #82bc00;
color: #fff;
box-shadow: 0 3px 8px 0 rgba(0,0,0,0.4);
}
.option-checkbox {
background: #fff;
border: 1px dashed #f7a711;
color: #f7a711;
padding: 2px 4px;
transition: 0.3s;
box-sizing: border-box;
cursor: pointer;
}
.option-checkbox.active {
color: #fff;
background: #f7a711;
box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3);
border-radius: 4px;
}
.selection-box {
position: relative;
}
.selection-box > select {
text-align: left;
width: 100%;
height: 20px;
padding: 0;
line-height: 20px;
background: transparent;
border: none;
border-bottom: 2px solid #656565;
color: #656565;
transition: 0.3s;
cursor: pointer;
outline: none;
box-sizing: border-box;
}
.selection-box > select > option {
background: white;
}
.selection-box > select:focus {
border-bottom: 2px solid #82bc00;
color: #82bc00;
box-shadow: 0 2px 6px 0 rgba(0,0,0,0.3);
}
.selection-box > label {
position: absolute;
cursor: pointer;
font-size: 12px;
color: #fff;
background: #656565;
padding: 0 4px;
right: 0;
top: 6px;
box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3);
}
.input-box {
position: relative;
}
.input-box > input[type=text] {
width: 100%;
background: transparent;
border: none;
color: #656565;
border-bottom: 2px solid #656565;
outline: none;
box-sizing: border-box;
transition: 0.3s;
}
.input-box > input[type=text]:focus {
color: #82bc00;
border-bottom: 2px solid #82bc00;
}
.input-box > label {
cursor: pointer;
position: absolute;
right: 0;
top: 5px;
font-size: 12px;
color: #fff;
background: #656565;
padding: 0 4px;
box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3);
}
.table-box > table {
width: 100%;
border-collapse: collapse;
}
.table-box > table > thead > tr {
border-bottom: 1px solid #000;
font-weight: bold;
}
.table-box > table > tbody > tr > td {
margin-top: 8px;
}
.table-box .icon {
padding: 0 2px;
color: #fff;
cursor: pointer;
border: 1px solid #fff;
border-radius: 3px;
background: transparent;
transition: 0.3s;
}
.table-box .icon:hover {
color: #fff;
box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3);
}
.icon.icon-edit {
border-color: #82bc00;
color: #82bc00;
}
.icon.icon-edit:hover {
background: #82bc00;
}
.icon.icon-delete {
border-color: #f7a711;
color: #f7a711;
}
.icon.icon-delete:hover {
background: #f7a711;
}
.input-date {
width: 99px;
border: none;
border-bottom: 1px solid ;
}
.input-date {
width: 99px;
background: transparent;
border: none;
color: #656565;
border-bottom: 2px solid #656565;
outline: none;
box-sizing: border-box;
transition: 0.3s;
}
.input-date:focus {
color: #82bc00;
border-bottom: 2px solid #82bc00;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'tslib':'npm:tslib/tslib.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-ja': 'npm:@mescius/spread-sheets-resources-ja/index.js',
'@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js',
'@mescius/spread-sheets-ganttsheet': 'npm:@mescius/spread-sheets-ganttsheet/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts',
meta: {
"*.component.ts": {
loader: "system.component-loader.js"
}
}
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);